#include <stdio.h>
#include <math.h>
#include "ams.h"

/************************************************************

The Qlib program library has resulted from the work conducted
over several years jointly by

 Laboratory of Telecommunications Technology of
 Helsinki University of Technology (HUT) and

 VTT Information Technology, Telecommunications

The following individuals have contributed to the library:

 Samuli Aalto, Jani Lakkakorpi, Ilkka Norros, Anssi Pirhonen
 and Jorma Virtamo.

The programs can be used and modified freely.

No claims are made about the correctness of the programs
and no liability is taken for any damage caused by the use
of the programs in the library.

Reports of bugs in the program can be sent to qlib@tct.hut.fi

*************************************************************/

double 
decrinv(AMS *m, double (*f)(AMS *, double), double p, double eps)
{
  double x=0.0,y,step=0.5;
  
  if (f(m, x) <= p) return 0.0;
  while ((y = f(m, x += (step *= 2))) > p);
  while (fabs((y = f(m, x += (step = (2*(y > p)-1)*fabs(step)/2)))-p) > eps);
  return x;
}

double 
GAMSinv(AMS *m, double p, double eps)
{
  return decrinv(m, GAMS,p,eps);
}

