/* File: indexsort.h
 *
 * Description: File indexsort.h ia a header file that contains descriptions
 * for functions with which it's possible to sort data without chancing the
 * positions in the orginal data. 
 *
 * Author: Vesa Timonen <Vesa.Timonen@hut.fi>
 * Last modified: 13.1.2002
 */

#ifndef _INDEXSORT_H
#define _INDEXSORT_H

#include <stdlib.h>

/* Function getCompareFunc ...
   @param dataPointer    pointer to the data that is compared
   @param getElemFunc    function pointer to a function that returns
                         an element in pointed position from pointed stucture
   @return               function pointer to the comparison function
*/
int (*getCompareFunc(void *dataPointer, double (*getElemFunc)(void *, int)))
     (const void *a, const void *b);

/* Function indexsort ...
   @param base           pointer to the index table
   @param nbr_elems      number of elements to be sorted
   @param data           pointer to the data structure in which the data 
                         to be sorted is
   @param getElemFunc    function pointer to a function that returns the
                         wanted elemnet in the pointed structure in pointed
			 position
*/
void index_sort(int *base, int nbr_elems, void *data, 
	       double (*getElemFunc)(void *, int));

#endif /* _INDEXSORT_H */
