(* BeginPackage["QlibC`"] *)

(************************************************************

 QlibC:

 -  simple wrapper for Qlib.m and qliblnk, replaces those
    functions of Qlib.m with faster C-versions, if exist.

************************************************************)

(************************************************************

The Qlib program library has resulted from the work conducted 
over several years jointly by 

  Laboratory of Telecommunications Technology of 
  Helsinki University of Technology (HUT) and VTT 
  Information Technology, Telecommunications
  
The following individuals have contributed to the library:
  
  Samuli Aalto, Jani Lakkakorpi, Ilkka Norros, Anssi Pirhonen,
  Vesa Timonen and Jorma Virtamo.
  
The programs can be used and modified freely.

No claims are made about the correctness of the programs
and no liability is taken for any damage caused by the use
of the programs in the library.

Reports of bugs in the program can be sent to qlib@tct.hut.fi

__
UpDates:

       04-19-2002  CreateNet and Dijkstra added by Vesa
       05-27-2002  CreateNet renamed as GabrielNet

Bugs:
       01-03-2002  M/D/1 etc queues have C-versions but not used
       
*************************************************************)


Needs[ "Qlib`",    "qlib.m"    ]; 
Needs[ "QlibLnk`", "qliblnk.m" ];

(* Use C-library counterparts *)
Berli      = Global`LnkBerli;
Berld      = Global`LnkBerld;
Xerl       = Global`LnkXerl;
Aerl       = Global`LnkAerl;
GabrielNet = Global`LnkGabrielNet;
Dijkstra   = Global`LnkDijkstra;

(*
Begin["`Private`"]
End[]
EndPackage[]
*)

