/*
 * This file automatically produced by .\mldev32\bin\mprep from:
 *	interface.tm
 * mprep Revision 8 Copyright (c) Wolfram Research, Inc. 1990-2000
 */

#define MPREP_REVISION 8


#include "mathlink.h"

int MLAbort = 0;
int MLDone  = 0;
long MLSpecialCharacter = '\0';
HANDLE MLInstance = (HANDLE)0;
HWND MLIconWindow = (HWND)0;

MLINK stdlink = 0;
MLEnvironment stdenv = 0;
MLYieldFunctionObject stdyielder = 0;
MLMessageHandlerObject stdhandler = 0;

#include <windows.h>
#include <stdlib.h>
#include <string.h>
#if WIN32_MATHLINK && !defined(_fstrncpy)
#       define _fstrncpy strncpy
#endif

#ifndef CALLBACK
#define CALLBACK FAR PASCAL
typedef LONG LRESULT;
typedef unsigned int UINT;
typedef WORD WPARAM;
typedef DWORD LPARAM;
#endif


LRESULT CALLBACK MLEXPORT
IconProcedure( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);

LRESULT CALLBACK MLEXPORT
IconProcedure( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch( msg){
	case WM_CLOSE:
		MLDone = 1;
		MLAbort = 1;
		break;
	case WM_QUERYOPEN:
		return 0;
	}
	return DefWindowProc( hWnd, msg, wParam, lParam);
}

#define _APISTR(i) #i
#define APISTR(i) _APISTR(i)

HWND MLInitializeIcon( HINSTANCE hInstance, int nCmdShow)
{
	char path_name[260], *icon_name;
	WNDCLASS  wc;
	HMODULE hdll;

	MLInstance = hInstance;
	if( ! nCmdShow) return (HWND)0;
#if WIN16_MATHLINK
	hdll = GetModuleHandle( "ml16i" APISTR(MLINTERFACE));
#else
	hdll = GetModuleHandle( "ml32i" APISTR(MLINTERFACE));
#endif

	(void)GetModuleFileName( hInstance, path_name, sizeof(path_name));
	icon_name = strrchr( path_name, '\\') + 1;
	*strchr( icon_name, '.') = '\0';

	wc.style = 0;
	wc.lpfnWndProc = IconProcedure;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	if( hdll)
		wc.hIcon = LoadIcon( hdll, "MLIcon");
	else
		wc.hIcon = LoadIcon( NULL, IDI_APPLICATION);
	wc.hCursor = LoadCursor( NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)GetStockObject( WHITE_BRUSH);
	wc.lpszMenuName =  (LPSTR) 0;
	wc.lpszClassName = "mprepIcon";
	(void)RegisterClass( &wc);

	MLIconWindow = CreateWindow( "mprepIcon", icon_name,
			WS_OVERLAPPEDWINDOW | WS_MINIMIZE, CW_USEDEFAULT,
			CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
			(HWND)0, (HMENU)0, hInstance, (void FAR*)0);

	if( MLIconWindow){
		ShowWindow( MLIconWindow, SW_MINIMIZE);
		UpdateWindow( MLIconWindow);
	}
	return MLIconWindow;
}


#if __BORLANDC__
#pragma argsused
#endif

MLYDEFN( devyield_result, MLDefaultYielder, ( MLINK mlp, MLYieldParameters yp))
{
	MSG msg;

#if !__BORLANDC__
	mlp = mlp; /* suppress unused warning */
	yp = yp; /* suppress unused warning */
#endif

	if( PeekMessage( &msg, (HWND)0, 0, 0, PM_REMOVE)){
		TranslateMessage( &msg);
		DispatchMessage( &msg);
	}
	return MLDone;
}


/********************************* end header *********************************/


# line 1 "interface.tm"
/* File: interface.tm
 * __
 * UpDates:
 * 18.04.2002 LnkCreateNet and LnkDijkstra added by Vesa
 * 05.05.2002 LnkDijkstra usage updated...
 * 27.05.2002 LnkCreateNet renamed as LnkGabrielNet and the interface&usage updated
 *            Function LnkShowNetwork added
 * 30.05.2002 Minor modifications to LnkGabrielNet/LnkShowNetwork: Context of optional arguments forced to 'System`'
 *            Now because context of opt.args in qlib.m is the same, no shadowing appears while simultaneous use
 */

#include "erlang.h"
#include "queuel.h"
#include "qlib.h"

# line 146 "interfacetm.c"


# line 196 "interface.tm"
/* begin: LnkGabrielNet */

# line 152 "interfacetm.c"


# line 222 "interface.tm"
/* end: LnkGabrielNet */

/* begin: LnkDijkstra */

# line 160 "interfacetm.c"


# line 239 "interface.tm"
/* end: LnkDijkstra */

/* begin: LnkShowNetwork */

/* NOTE! This function is a pure Mathematica function that uses no external programs          */
/*       It is added to make possible to create graphs without installing the qlib.m package  */
/*       This implementation of ShowRoutes is identical with corresponding function in qlib.m */

# line 172 "interfacetm.c"


# line 279 "interface.tm"
/* end: LnkShowNetwork */
# line 177 "interfacetm.c"


double Berl_d P(( double _tp1, double _tp2));

#if MLPROTOTYPES
static int _tr0( MLINK mlp)
#else
static int _tr0(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	double _tp0;
	double _tp1;
	double _tp2;
	if ( ! MLGetReal( mlp, &_tp1) ) goto L0;
	if ( ! MLGetReal( mlp, &_tp2) ) goto L1;
	if ( ! MLNewPacket(mlp) ) goto L2;

	_tp0 = Berl_d(_tp1, _tp2);

	res = MLAbort ?
		MLPutFunction( mlp, "Abort", 0) : MLPutReal( mlp, _tp0);
L2: L1: 
L0:	return res;
} /* _tr0 */


double Berl_i P(( int _tp1, double _tp2));

#if MLPROTOTYPES
static int _tr1( MLINK mlp)
#else
static int _tr1(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	double _tp0;
	int _tp1;
	double _tp2;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetReal( mlp, &_tp2) ) goto L1;
	if ( ! MLNewPacket(mlp) ) goto L2;

	_tp0 = Berl_i(_tp1, _tp2);

	res = MLAbort ?
		MLPutFunction( mlp, "Abort", 0) : MLPutReal( mlp, _tp0);
L2: L1: 
L0:	return res;
} /* _tr1 */


double Xerl P(( double _tp1, double _tp2));

#if MLPROTOTYPES
static int _tr2( MLINK mlp)
#else
static int _tr2(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	double _tp0;
	double _tp1;
	double _tp2;
	if ( ! MLGetReal( mlp, &_tp1) ) goto L0;
	if ( ! MLGetReal( mlp, &_tp2) ) goto L1;
	if ( ! MLNewPacket(mlp) ) goto L2;

	_tp0 = Xerl(_tp1, _tp2);

	res = MLAbort ?
		MLPutFunction( mlp, "Abort", 0) : MLPutReal( mlp, _tp0);
L2: L1: 
L0:	return res;
} /* _tr2 */


double Aerl P(( double _tp1, double _tp2));

#if MLPROTOTYPES
static int _tr3( MLINK mlp)
#else
static int _tr3(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	double _tp0;
	double _tp1;
	double _tp2;
	if ( ! MLGetReal( mlp, &_tp1) ) goto L0;
	if ( ! MLGetReal( mlp, &_tp2) ) goto L1;
	if ( ! MLNewPacket(mlp) ) goto L2;

	_tp0 = Aerl(_tp1, _tp2);

	res = MLAbort ?
		MLPutFunction( mlp, "Abort", 0) : MLPutReal( mlp, _tp0);
L2: L1: 
L0:	return res;
} /* _tr3 */


double Qndd1 P(( double _tp1, int _tp2, double _tp3));

#if MLPROTOTYPES
static int _tr4( MLINK mlp)
#else
static int _tr4(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	double _tp0;
	double _tp1;
	int _tp2;
	double _tp3;
	if ( ! MLGetReal( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetReal( mlp, &_tp3) ) goto L2;
	if ( ! MLNewPacket(mlp) ) goto L3;

	_tp0 = Qndd1(_tp1, _tp2, _tp3);

	res = MLAbort ?
		MLPutFunction( mlp, "Abort", 0) : MLPutReal( mlp, _tp0);
L3: L2: L1: 
L0:	return res;
} /* _tr4 */


double Qsdd1 P(( double _tp1, doublep_nt _tp2, long _tpl2));

#if MLPROTOTYPES
static int _tr5( MLINK mlp)
#else
static int _tr5(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	double _tp0;
	double _tp1;
	doublep_nt _tp2;
	long _tpl2;
	if ( ! MLGetReal( mlp, &_tp1) ) goto L0;
	if ( ! MLGetRealList( mlp, &_tp2, &_tpl2) ) goto L1;
	if ( ! MLNewPacket(mlp) ) goto L2;

	_tp0 = Qsdd1(_tp1, _tp2, _tpl2);

	res = MLAbort ?
		MLPutFunction( mlp, "Abort", 0) : MLPutReal( mlp, _tp0);
L2:	MLDisownRealList( mlp, _tp2, _tpl2);
L1: 
L0:	return res;
} /* _tr5 */


double Qmd1 P(( double _tp1, double _tp2));

#if MLPROTOTYPES
static int _tr6( MLINK mlp)
#else
static int _tr6(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	double _tp0;
	double _tp1;
	double _tp2;
	if ( ! MLGetReal( mlp, &_tp1) ) goto L0;
	if ( ! MLGetReal( mlp, &_tp2) ) goto L1;
	if ( ! MLNewPacket(mlp) ) goto L2;

	_tp0 = Qmd1(_tp1, _tp2);

	res = MLAbort ?
		MLPutFunction( mlp, "Abort", 0) : MLPutReal( mlp, _tp0);
L2: L1: 
L0:	return res;
} /* _tr6 */


double Qmxd1 P(( double _tp1, double _tp2, doublep_nt _tp3, long _tpl3));

#if MLPROTOTYPES
static int _tr7( MLINK mlp)
#else
static int _tr7(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	double _tp0;
	double _tp1;
	double _tp2;
	doublep_nt _tp3;
	long _tpl3;
	if ( ! MLGetReal( mlp, &_tp1) ) goto L0;
	if ( ! MLGetReal( mlp, &_tp2) ) goto L1;
	if ( ! MLGetRealList( mlp, &_tp3, &_tpl3) ) goto L2;
	if ( ! MLNewPacket(mlp) ) goto L3;

	_tp0 = Qmxd1(_tp1, _tp2, _tp3, _tpl3);

	res = MLAbort ?
		MLPutFunction( mlp, "Abort", 0) : MLPutReal( mlp, _tp0);
L3:	MLDisownRealList( mlp, _tp3, _tpl3);
L2: L1: 
L0:	return res;
} /* _tr7 */


void lnkMg1 P(( int _tp1, double _tp2));

#if MLPROTOTYPES
static int _tr8( MLINK mlp)
#else
static int _tr8(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	double _tp2;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetReal( mlp, &_tp2) ) goto L1;

	lnkMg1(_tp1, _tp2);

	res = 1;
 L1: 
L0:	return res;
} /* _tr8 */


void lnkSumMd1 P(( int _tp1, double _tp2));

#if MLPROTOTYPES
static int _tr9( MLINK mlp)
#else
static int _tr9(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	double _tp2;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetReal( mlp, &_tp2) ) goto L1;
	if ( ! MLNewPacket(mlp) ) goto L2;

	lnkSumMd1(_tp1, _tp2);

	res = 1;
L2: L1: 
L0:	return res;
} /* _tr9 */


void lnkRecMd1 P(( int _tp1, double _tp2));

#if MLPROTOTYPES
static int _tr10( MLINK mlp)
#else
static int _tr10(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	double _tp2;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetReal( mlp, &_tp2) ) goto L1;
	if ( ! MLNewPacket(mlp) ) goto L2;

	lnkRecMd1(_tp1, _tp2);

	res = 1;
L2: L1: 
L0:	return res;
} /* _tr10 */


double IntFmd1 P(( int _tp1, double _tp2));

#if MLPROTOTYPES
static int _tr11( MLINK mlp)
#else
static int _tr11(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	double _tp0;
	int _tp1;
	double _tp2;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetReal( mlp, &_tp2) ) goto L1;
	if ( ! MLNewPacket(mlp) ) goto L2;

	_tp0 = IntFmd1(_tp1, _tp2);

	res = MLAbort ?
		MLPutFunction( mlp, "Abort", 0) : MLPutReal( mlp, _tp0);
L2: L1: 
L0:	return res;
} /* _tr11 */


double Fmd1 P(( double _tp1, double _tp2));

#if MLPROTOTYPES
static int _tr12( MLINK mlp)
#else
static int _tr12(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	double _tp0;
	double _tp1;
	double _tp2;
	if ( ! MLGetReal( mlp, &_tp1) ) goto L0;
	if ( ! MLGetReal( mlp, &_tp2) ) goto L1;
	if ( ! MLNewPacket(mlp) ) goto L2;

	_tp0 = Fmd1(_tp1, _tp2);

	res = MLAbort ?
		MLPutFunction( mlp, "Abort", 0) : MLPutReal( mlp, _tp0);
L2: L1: 
L0:	return res;
} /* _tr12 */


void lnkMdn P(( double _tp1, double _tp2, int _tp3));

#if MLPROTOTYPES
static int _tr13( MLINK mlp)
#else
static int _tr13(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	double _tp1;
	double _tp2;
	int _tp3;
	if ( ! MLGetReal( mlp, &_tp1) ) goto L0;
	if ( ! MLGetReal( mlp, &_tp2) ) goto L1;
	if ( ! MLGetInteger( mlp, &_tp3) ) goto L2;
	if ( ! MLNewPacket(mlp) ) goto L3;

	lnkMdn(_tp1, _tp2, _tp3);

	res = 1;
L3: L2: L1: 
L0:	return res;
} /* _tr13 */


double IntFmdn P(( int _tp1, double _tp2, int _tp3));

#if MLPROTOTYPES
static int _tr14( MLINK mlp)
#else
static int _tr14(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	double _tp0;
	int _tp1;
	double _tp2;
	int _tp3;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetReal( mlp, &_tp2) ) goto L1;
	if ( ! MLGetInteger( mlp, &_tp3) ) goto L2;
	if ( ! MLNewPacket(mlp) ) goto L3;

	_tp0 = IntFmdn(_tp1, _tp2, _tp3);

	res = MLAbort ?
		MLPutFunction( mlp, "Abort", 0) : MLPutReal( mlp, _tp0);
L3: L2: L1: 
L0:	return res;
} /* _tr14 */


double Fmdn P(( double _tp1, double _tp2, int _tp3));

#if MLPROTOTYPES
static int _tr15( MLINK mlp)
#else
static int _tr15(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	double _tp0;
	double _tp1;
	double _tp2;
	int _tp3;
	if ( ! MLGetReal( mlp, &_tp1) ) goto L0;
	if ( ! MLGetReal( mlp, &_tp2) ) goto L1;
	if ( ! MLGetInteger( mlp, &_tp3) ) goto L2;
	if ( ! MLNewPacket(mlp) ) goto L3;

	_tp0 = Fmdn(_tp1, _tp2, _tp3);

	res = MLAbort ?
		MLPutFunction( mlp, "Abort", 0) : MLPutReal( mlp, _tp0);
L3: L2: L1: 
L0:	return res;
} /* _tr15 */


double Fekdn P(( double _tp1, double _tp2, int _tp3, int _tp4));

#if MLPROTOTYPES
static int _tr16( MLINK mlp)
#else
static int _tr16(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	double _tp0;
	double _tp1;
	double _tp2;
	int _tp3;
	int _tp4;
	if ( ! MLGetReal( mlp, &_tp1) ) goto L0;
	if ( ! MLGetReal( mlp, &_tp2) ) goto L1;
	if ( ! MLGetInteger( mlp, &_tp3) ) goto L2;
	if ( ! MLGetInteger( mlp, &_tp4) ) goto L3;
	if ( ! MLNewPacket(mlp) ) goto L4;

	_tp0 = Fekdn(_tp1, _tp2, _tp3, _tp4);

	res = MLAbort ?
		MLPutFunction( mlp, "Abort", 0) : MLPutReal( mlp, _tp0);
L4: L3: L2: L1: 
L0:	return res;
} /* _tr16 */


double Fend1 P(( double _tp1, int _tp2, double _tp3));

#if MLPROTOTYPES
static int _tr17( MLINK mlp)
#else
static int _tr17(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	double _tp0;
	double _tp1;
	int _tp2;
	double _tp3;
	if ( ! MLGetReal( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetReal( mlp, &_tp3) ) goto L2;
	if ( ! MLNewPacket(mlp) ) goto L3;

	_tp0 = Fend1(_tp1, _tp2, _tp3);

	res = MLAbort ?
		MLPutFunction( mlp, "Abort", 0) : MLPutReal( mlp, _tp0);
L3: L2: L1: 
L0:	return res;
} /* _tr17 */


double lnkbmitra P(( int _tp1, int _tp2, double _tp3, intp_nt _tp4, long _tpl4, doublep_nt _tp5, long _tpl5));

#if MLPROTOTYPES
static int _tr18( MLINK mlp)
#else
static int _tr18(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	double _tp0;
	int _tp1;
	int _tp2;
	double _tp3;
	intp_nt _tp4;
	long _tpl4;
	doublep_nt _tp5;
	long _tpl5;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetReal( mlp, &_tp3) ) goto L2;
	if ( ! MLGetIntegerList( mlp, &_tp4, &_tpl4) ) goto L3;
	if ( ! MLGetRealList( mlp, &_tp5, &_tpl5) ) goto L4;
	if ( ! MLNewPacket(mlp) ) goto L5;

	_tp0 = lnkbmitra(_tp1, _tp2, _tp3, _tp4, _tpl4, _tp5, _tpl5);

	res = MLAbort ?
		MLPutFunction( mlp, "Abort", 0) : MLPutReal( mlp, _tp0);
L5:	MLDisownRealList( mlp, _tp5, _tpl5);
L4:	MLDisownIntegerList( mlp, _tp4, _tpl4);
L3: L2: L1: 
L0:	return res;
} /* _tr18 */


double lnkbkaufman P(( int _tp1, int _tp2, int _tp3, intp_nt _tp4, long _tpl4, doublep_nt _tp5, long _tpl5));

#if MLPROTOTYPES
static int _tr19( MLINK mlp)
#else
static int _tr19(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	double _tp0;
	int _tp1;
	int _tp2;
	int _tp3;
	intp_nt _tp4;
	long _tpl4;
	doublep_nt _tp5;
	long _tpl5;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;
	if ( ! MLGetInteger( mlp, &_tp3) ) goto L2;
	if ( ! MLGetIntegerList( mlp, &_tp4, &_tpl4) ) goto L3;
	if ( ! MLGetRealList( mlp, &_tp5, &_tpl5) ) goto L4;
	if ( ! MLNewPacket(mlp) ) goto L5;

	_tp0 = lnkbkaufman(_tp1, _tp2, _tp3, _tp4, _tpl4, _tp5, _tpl5);

	res = MLAbort ?
		MLPutFunction( mlp, "Abort", 0) : MLPutReal( mlp, _tp0);
L5:	MLDisownRealList( mlp, _tp5, _tpl5);
L4:	MLDisownIntegerList( mlp, _tp4, _tpl4);
L3: L2: L1: 
L0:	return res;
} /* _tr19 */


void lnkgabrielnet P(( int _tp1, double _tp2, int _tp3));

#if MLPROTOTYPES
static int _tr20( MLINK mlp)
#else
static int _tr20(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	double _tp2;
	int _tp3;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetReal( mlp, &_tp2) ) goto L1;
	if ( ! MLGetInteger( mlp, &_tp3) ) goto L2;
	if ( ! MLNewPacket(mlp) ) goto L3;

	lnkgabrielnet(_tp1, _tp2, _tp3);

	res = 1;
L3: L2: L1: 
L0:	return res;
} /* _tr20 */


void lnkdijkstra P(( int _tp1, int _tp2));

#if MLPROTOTYPES
static int _tr21( MLINK mlp)
#else
static int _tr21(mlp) MLINK mlp;
#endif
{
	int	res = 0;
	int _tp1;
	int _tp2;
	if ( ! MLGetInteger( mlp, &_tp1) ) goto L0;
	if ( ! MLGetInteger( mlp, &_tp2) ) goto L1;

	lnkdijkstra(_tp1, _tp2);

	res = 1;
 L1: 
L0:	return res;
} /* _tr21 */


static struct func {
	int   f_nargs;
	int   manual;
	int   (*f_func)P((MLINK));
	char  *f_name;
	} _tramps[22] = {
		{ 2, 0, _tr0, "Berl_d" },
		{ 2, 0, _tr1, "Berl_i" },
		{ 2, 0, _tr2, "Xerl" },
		{ 2, 0, _tr3, "Aerl" },
		{ 3, 0, _tr4, "Qndd1" },
		{ 2, 0, _tr5, "Qsdd1" },
		{ 2, 0, _tr6, "Qmd1" },
		{ 3, 0, _tr7, "Qmxd1" },
		{ 2, 2, _tr8, "lnkMg1" },
		{ 2, 0, _tr9, "lnkSumMd1" },
		{ 2, 0, _tr10, "lnkRecMd1" },
		{ 2, 0, _tr11, "IntFmd1" },
		{ 2, 0, _tr12, "Fmd1" },
		{ 3, 0, _tr13, "lnkMdn" },
		{ 3, 0, _tr14, "IntFmdn" },
		{ 3, 0, _tr15, "Fmdn" },
		{ 4, 0, _tr16, "Fekdn" },
		{ 3, 0, _tr17, "Fend1" },
		{ 5, 0, _tr18, "lnkbmitra" },
		{ 5, 0, _tr19, "lnkbkaufman" },
		{ 3, 0, _tr20, "lnkgabrielnet" },
		{ 2, 2, _tr21, "lnkdijkstra" }
		};

static char* evalstrs[] = {
	"LnkBerld::usage = \"LnkBerld[x, a] returns the Erlang loss probab",
	"ility for a trunk group x, where x is a real valued variable (do",
	"uble). Second parameter is the Poisson traffic a.\"",
	(char*)0,
	"LnkBerli::usage = \"LnkBerli[n, a] returns the Erlang loss probab",
	"ility for a integer valued trunk group n and Poisson traffic a.\"",
	(char*)0,
	"LnkXerl::usage = \"LnkXerl[b, a] returns the number of trunks for",
	" a loss probability b and Poisson traffic a.\"",
	(char*)0,
	"LnkAerl::usage = \"LnkAerl[x, b] returns the Poisson traffic valu",
	"e for a trunk group x and loss probability b.\"",
	(char*)0,
	"LnkQndd1::usage = \"LnkQndd1[x, N, D] returns the virtual waiting",
	" time distribution for the N*D/D/1 queuing system. The system ha",
	"s N deterministic sources with the same period D, so that the lo",
	"ad level of the system is N/D.\"",
	(char*)0,
	"LnkQsdd1::usage = \"LnkQsdd1[x, D, N] returns the virtual waiting",
	" time distribution for the [Sigma]Di/D/1 queuing system. The sys",
	"tem has N deterministic sources, each having it's own period D, ",
	"and a constant service time. Table of periods is given by D.\"",
	(char*)0,
	"LnkQmd1::usage = \"LnkQmd1[x, rho] returns the virtual waiting ti",
	"me distribution for the M/D/1 queuing system. The system has Poi",
	"sson arrivals and deterministic service time. Rho is the load le",
	"vel of the system.\"",
	(char*)0,
	"LnkQmxd1::usage = \"LnkQmxd1[x, rho, D] returns the unfinished wo",
	"rk tail distribution for the M^x/D/1 queuing system. The system ",
	"has Poisson batch arrivals and deterministic service time. Param",
	"eter x is the amount of unfinished work in the system, rho is th",
	"e load level of the system and parameter D is the distribution (",
	"table) of the batch size probabilities {p1, p2, p3...}. The sum ",
	"of these probabilities has to be exactly 1.\"",
	(char*)0,
	"LnkMg1::usage = \"LnkMg1[x, rho, n] gives the queue length probab",
	"ilities for the M/G/1 queuing model with load level rho and serv",
	"ice time distribution function N ( If N=1: If[x<1,0,1]; If N=2: ",
	"1-Exp[-x] ).\"",
	(char*)0,
	"LnkSumMd1::usage = \"LnkSumMd1[x, rho] calculates the state proba",
	"bilities of a M/D/1 queue with load level rho.\"",
	(char*)0,
	"LnkRecMd1::usage = \"LnkRecMd1[x, rho] calculates the state proba",
	"bilities of a M/D/1 queue with load level rho. This function use",
	"s a recursive algorithm.\"",
	(char*)0,
	"LnkIntFmd1::usage = \"LnkIntFmd1[N, rho] is the M/D/1 (virtual) w",
	"aiting time distribution function (for integral values of x) wit",
	"h load level rho. Service time h is assumed to be 1.\"",
	(char*)0,
	"LnkFmd1::usage = \"LnkFmd1[x, rho] is the M/D/1 (virtual) waiting",
	" time distribution function (it calculates the probability that ",
	"waiting time W is smaller than x) with load level rho. Service t",
	"ime h is assumed to be 1.\"",
	(char*)0,
	"LnkMdn::usage = \"LnkMdn[x, rho, n] calculates the state probabil",
	"ities of a M/D/n queue with load level rho and n servers. Accura",
	"cy goal is 10^-12.\"",
	(char*)0,
	"LnkIntFmdn::usage = \"LnkIntFmdn[N, rho, n] is the M/D/n (virtual",
	") waiting time distribution function (for integral values of x) ",
	"with load level rho. Service time h is assumed to be 1.\"",
	(char*)0,
	"LnkFmdn::usage = \"LnkFmdn[x, rho, n] is the M/D/n (virtual) wait",
	"ing time distribution function (it calculates the probability th",
	"at waiting time W is smaller than x) with load level rho. Servic",
	"e time h is assumed to be 1.\"",
	(char*)0,
	"LnkFekdn::usage = \"LnkFekdn[x, rho, k, n] is the E_k/D/n (virtua",
	"l) waiting time distribution function (it calculates the probabi",
	"lity that waiting time W is smaller than x) with load level rho.",
	" Service time h is assumed to be 1.\"",
	(char*)0,
	"LnkFend1::usage = \"LnkFend1[x, n, rho] is the E_n/D/1 (virtual) ",
	"waiting time distribution function (it calculates the probabilit",
	"y that waiting time W is smaller than x) with load level rho. Se",
	"rvice time h is assumed to be 1.\"",
	(char*)0,
	"LnkBmitra::usage = \"LnkBmitra[j, J, C, d, a] returns the blockin",
	"g probability for a traffic class j (1<=j<=J) from a number of c",
	"lasses J. C is the total capacity of the link. Each traffic clas",
	"s is characterized by it's bandwidth. d is the list of these val",
	"ues and a is the list of traffic intensities for each class.\"",
	(char*)0,
	"LnkBkaufman::usage = \"LnkBkaufman[j, J, C, d, a] returns the blo",
	"cking probability for a traffic class j (1<=j<=J) from a number ",
	"of classes J. C is the total capacity of the link. Each traffic ",
	"class is characterized by it's bandwidth. d is the list of these",
	" values and a is the list of traffic intensities for each class.",
	" LnkBkaufman is implemented by using the Kaufman and Roberts rec",
	"ursion formula.\"",
	(char*)0,
	"Options[LnkGabrielNet] =   {System`Scale -> 1., System`Shape -> ",
	"Circle, System`CreateGraph -> False, System`Index -> False, Syst",
	"em`Graph -> False};",
	(char*)0,
	"LnkGabrielNet[nbrNds_, options___] :=    Module[{d, points, grap",
	"h = {}, i, j, scl, shp},   scl = Scale /. {options} /. Options[L",
	"nkGabrielNet];   shp = Shape /. {options} /. Options[LnkGabrielN",
	"et] /. {Circle -> 0, Box -> 1};   {points, d} = LnkGabrielNetCor",
	"e[nbrNds, N[scl], shp];   d = d /. {-1. -> Infinity};   If[(Crea",
	"teGraph /. {options} /. Options[LnkGabrielNet]) || (Graph /. {op",
	"tions} /. Options[LnkGabrielNet]), (* Create the graph *)      {",
	"d, points, RCore[{d, points},{},{Index, Graph} /. {options} /. O",
	"ptions[LnkGabrielNet]]},     (* do not create or return the grap",
	"h *)      {d, points}]];",
	(char*)0,
	"LnkGabrielNet::usage = \"LnkGabrielNet[NbrOfNodes] generates a ra",
	"ndom network containing 'NbrOfNodes' nodes using an external c-p",
	"rogram via MathLink. The positions of the nodes are drawn from u",
	"niform distribution and node pairs satisfying the gabriel criter",
	"ion are connected. Function returns a list containing two or thr",
	"ee elements: distance/cost matrix, list of the node coordinates ",
	"and, if wanted, a Graphics object containing an image of the net",
	"work.\\nOptional arguments:\\n Shape      \\tCircle/Box\\t the shape of ",
	"the network (default 'Circle')\\n Scale      \\t          \\t the size",
	" of the circle radius/box edge (def. '1')\\n CreateGraph\\tFalse/Tru",
	"e\\t whether to create the graph (def. 'False')\\n Index      \\tFalse",
	"/True\\t whether to include node indices to the graph (def. 'False",
	"')\\n Graph      \\tFalse/True\\t whether to show the graph (def. 'Fal",
	"se')\"",
	(char*)0,
	"LnkDijkstra[Distances_, Root_, Target_:0] :=    LnkDijkstraCore[",
	"Root - 1, Target - 1, Distances /. {Infinity -> -1}] + {1, 1, 0}",
	";",
	(char*)0,
	"LnkDijkstra::usage = \"LnkDijkstra[dist, root, dest] finds out th",
	"e shortest path from node 'root' to node 'dest' with Dijkstras a",
	"lgorithm using an external c-program via MathLink. If 'dest' is ",
	"not given, function finds out paths to all nodes in the net. Mat",
	"rix 'dist' is the distance/cost matrix between all nodes in the ",
	"network (if there is no connection, the distance/cost must be 'I",
	"nfinity'). Function returns a list containing three elements: li",
	"st of nodes that belong to the path, list of previous nodes of c",
	"orresponding node in the first list and total distance/cost of c",
	"orresponding node in the first list to the node 'root'. \\nIf ther",
	"e is no connection to some nodes, those are left out from the re",
	"sults. If there is no connection from 'root' to specific 'dest',",
	" result will be list containing only the root node.\"",
	(char*)0,
	"Options[LnkShowNetwork] = {System`Index -> False, System`Graph -",
	"> False};",
	(char*)0,
	"LnkShowNetwork[GraphData_, RouteData_, options___] :=    RCore[G",
	"raphData, RouteData, {Index, Graph} /. {options} /. Options[LnkS",
	"howNetwork]];",
	(char*)0,
	"RCore[GraphData_, RouteData_, {Index_, Graph_}] := Module[{net={",
	"}, graph, root},     If[Length[GraphData] == 2, (* no graph crea",
	"ted *)        Do[If[GraphData[[1]][[i,j]] != Infinity, (* points",
	" i and j connected *)              net = net~Join~{{GraphData[[2",
	",i]], GraphData[[2,j]]}}],           {i,1,Length[GraphData[[1]]]",
	"},{j,i+1,Length[GraphData[[1]]]}];        net = {GrayLevel[.3], ",
	"Line /@ net};        net = {net, GrayLevel[0], AbsolutePointSize",
	"[5], Point /@ GraphData[[2]]};        If[Index, (* add indices *",
	")           net = {net, RGBColor[0, 0.4, 0.2],           MapInde",
	"xed[Text[First[#2], #1, {-2, 0}, Background -> GrayLevel[.95]]&,",
	" GraphData[[2]]]}];        net = Graphics[net],        net = Gra",
	"phData[[3]] (* else *)];          If[RouteData=!={}, (* path inf",
	"o is known *)       graph = Line[GraphData[[2, #]]] & /@ Transpo",
	"se[Take[RouteData, 2]];       root = {PointSize[.035], RGBColor[",
	"1, .5, .1], Point[GraphData[[2, RouteData[[1, 1]]]]]};       gra",
	"ph = {root, {AbsoluteThickness[2], graph}};       If[Index, grap",
	"h = {graph, RGBColor[.3, .1, 0],           Text[#, GraphData[[2,",
	" #]], {-2, 0}, Background -> GrayLevel[.95]] & /@ RouteData[[1]]",
	"}];       If[Length[GraphData]==3,graph = {GraphData[[3]], Graph",
	"ics[graph]},graph = {net, Graphics[graph]}],       graph=net (* ",
	"else *)];            If[Graph, Show[graph, AspectRatio -> Automa",
	"tic, PlotRange -> All];];     graph];",
	(char*)0,
	"LnkShowNetwork::usage = \"LnkShowNetwork[netData, pathData] List ",
	"'netData' contains information of the network in the output form",
	" of function 'LnkGabrielNet' and list 'pathData' contains inform",
	"ation of the route(s) in the output form of function 'LnkDijkstr",
	"a'. Function returns a list of two Graphics objects that contain",
	"s an image of the network and the path(s).\\nIf list 'pathData' is",
	" empty i.e. {}, returns the function only the graph of the netwo",
	"rk.\\nOptional arguments:\\n Index \\tFalse/True \\t whether to include ",
	"node indices to the graph (default 'False')\\n Graph \\tFalse/True \\t",
	" whether to show the created graph (def. 'False')\"",
	(char*)0,
	(char*)0
};
#define CARDOF_EVALSTRS 29

static int _definepattern P(( MLINK, char*, char*, int));

static int _doevalstr P(( MLINK, int));

int  _MLDoCallPacket P(( MLINK, struct func[], int));


#if MLPROTOTYPES
int MLInstall( MLINK mlp)
#else
int MLInstall(mlp) MLINK mlp;
#endif
{
	int _res;
	_res = MLConnect(mlp);
	if (_res) _res = _doevalstr( mlp, 0);
	if (_res) _res = _definepattern(mlp, "LnkBerld[x_, a_]", "{x,a}", 0);
	if (_res) _res = _doevalstr( mlp, 1);
	if (_res) _res = _definepattern(mlp, "LnkBerli[n_, a_]", "{n,a}", 1);
	if (_res) _res = _doevalstr( mlp, 2);
	if (_res) _res = _definepattern(mlp, "LnkXerl[b_, a_]", "{b,a}", 2);
	if (_res) _res = _doevalstr( mlp, 3);
	if (_res) _res = _definepattern(mlp, "LnkAerl[x_, b_]", "{x,b}", 3);
	if (_res) _res = _doevalstr( mlp, 4);
	if (_res) _res = _definepattern(mlp, "LnkQndd1[x_, N_, D_]", "{x, N, D}", 4);
	if (_res) _res = _doevalstr( mlp, 5);
	if (_res) _res = _definepattern(mlp, "LnkQsdd1[x_, D:{__}]", "{x, D}", 5);
	if (_res) _res = _doevalstr( mlp, 6);
	if (_res) _res = _definepattern(mlp, "LnkQmd1[x_, rho_]", "{x, rho}", 6);
	if (_res) _res = _doevalstr( mlp, 7);
	if (_res) _res = _definepattern(mlp, "LnkQmxd1[x_, rho_, D:{__}]", "{x, rho, D}", 7);
	if (_res) _res = _doevalstr( mlp, 8);
	if (_res) _res = _definepattern(mlp, "LnkMg1[x_, rho_, D_]", "{x, rho, D}", 8);
	if (_res) _res = _doevalstr( mlp, 9);
	if (_res) _res = _definepattern(mlp, "LnkSumMd1[x_, rho_]", "{x, rho}", 9);
	if (_res) _res = _doevalstr( mlp, 10);
	if (_res) _res = _definepattern(mlp, "LnkRecMd1[x_, rho_]", "{x, rho}", 10);
	if (_res) _res = _doevalstr( mlp, 11);
	if (_res) _res = _definepattern(mlp, "LnkIntFmd1[N_, rho_]", "{N, rho}", 11);
	if (_res) _res = _doevalstr( mlp, 12);
	if (_res) _res = _definepattern(mlp, "LnkFmd1[x_, rho_]", "{x, rho}", 12);
	if (_res) _res = _doevalstr( mlp, 13);
	if (_res) _res = _definepattern(mlp, "LnkMdn[x_, rho_, n_]", "{x, rho, n}", 13);
	if (_res) _res = _doevalstr( mlp, 14);
	if (_res) _res = _definepattern(mlp, "LnkIntFmdn[N_, rho_, n_]", "{N, rho, n}", 14);
	if (_res) _res = _doevalstr( mlp, 15);
	if (_res) _res = _definepattern(mlp, "LnkFmdn[x_, rho_, n_]", "{x, rho, n}", 15);
	if (_res) _res = _doevalstr( mlp, 16);
	if (_res) _res = _definepattern(mlp, "LnkFekdn[x_, rho_, k_, n_]", "{x, rho, k, n}", 16);
	if (_res) _res = _doevalstr( mlp, 17);
	if (_res) _res = _definepattern(mlp, "LnkFend1[x_, n_, rho_]", "{x, n, rho}", 17);
	if (_res) _res = _doevalstr( mlp, 18);
	if (_res) _res = _definepattern(mlp, "LnkBmitra[j_Integer, J_Integer, C_, d:{__}, a:{__}]", "{j, J, C, d, a}", 18);
	if (_res) _res = _doevalstr( mlp, 19);
	if (_res) _res = _definepattern(mlp, "LnkBkaufman[k_Integer, K_Integer, C_, dk:{__}, ak:{__}]", "{k, K, C, dk, ak}", 19);
	if (_res) _res = _definepattern(mlp, "LnkGabrielNetCore[NbrOfNodes_Integer, Scl_Real, Shp_Integer]", "{ NbrOfNodes, Scl, Shp }", 20);
	if (_res) _res = _doevalstr( mlp, 20);
	if (_res) _res = _doevalstr( mlp, 21);
	if (_res) _res = _doevalstr( mlp, 22);
	if (_res) _res = _definepattern(mlp, "LnkDijkstraCore[Root_Integer, Target_Integer, Distances_List]", "{ Root, Target, Distances }", 21);
	if (_res) _res = _doevalstr( mlp, 23);
	if (_res) _res = _doevalstr( mlp, 24);
	if (_res) _res = _doevalstr( mlp, 25);
	if (_res) _res = _doevalstr( mlp, 26);
	if (_res) _res = _doevalstr( mlp, 27);
	if (_res) _res = _doevalstr( mlp, 28);
	if (_res) _res = MLPutSymbol( mlp, "End");
	if (_res) _res = MLFlush( mlp);
	return _res;
} /* MLInstall */


#if MLPROTOTYPES
int MLDoCallPacket( MLINK mlp)
#else
int MLDoCallPacket( mlp) MLINK mlp;
#endif
{
	return _MLDoCallPacket( mlp, _tramps, 22);
} /* MLDoCallPacket */

/******************************* begin trailer ********************************/

#ifndef EVALSTRS_AS_BYTESTRINGS
#	define EVALSTRS_AS_BYTESTRINGS 1
#endif

#if CARDOF_EVALSTRS
static int  _doevalstr( MLINK mlp, int n)
{
	long bytesleft, charsleft, bytesnow;
#if !EVALSTRS_AS_BYTESTRINGS
	long charsnow;
#endif
	char **s, **p;
	char *t;

	s = evalstrs;
	while( n-- > 0){
		if( *s == 0) break;
		while( *s++ != 0){}
	}
	if( *s == 0) return 0;
	bytesleft = 0;
	charsleft = 0;
	p = s;
	while( *p){
		t = *p; while( *t) ++t;
		bytesnow = t - *p;
		bytesleft += bytesnow;
		charsleft += bytesnow;
#if !EVALSTRS_AS_BYTESTRINGS
		t = *p;
		charsleft -= MLCharacterOffset( &t, t + bytesnow, bytesnow);
		/* assert( t == *p + bytesnow); */
#endif
		++p;
	}


	MLPutNext( mlp, MLTKSTR);
#if EVALSTRS_AS_BYTESTRINGS
	p = s;
	while( *p){
		t = *p; while( *t) ++t;
		bytesnow = t - *p;
		bytesleft -= bytesnow;
		MLPut8BitCharacters( mlp, bytesleft, (unsigned char*)*p, bytesnow);
		++p;
	}
#else
	MLPut7BitCount( mlp, charsleft, bytesleft);
	p = s;
	while( *p){
		t = *p; while( *t) ++t;
		bytesnow = t - *p;
		bytesleft -= bytesnow;
		t = *p;
		charsnow = bytesnow - MLCharacterOffset( &t, t + bytesnow, bytesnow);
		/* assert( t == *p + bytesnow); */
		charsleft -= charsnow;
		MLPut7BitCharacters(  mlp, charsleft, *p, bytesnow, charsnow);
		++p;
	}
#endif
	return MLError( mlp) == MLEOK;
}
#endif /* CARDOF_EVALSTRS */


static int  _definepattern( MLINK mlp, char *patt, char *args, int func_n)
{
	MLPutFunction( mlp, "DefineExternal", (long)3);
	  MLPutString( mlp, patt);
	  MLPutString( mlp, args);
	  MLPutInteger( mlp, func_n);
	return !MLError(mlp);
} /* _definepattern */


int _MLDoCallPacket( MLINK mlp, struct func functable[], int nfuncs)
{
	long len;
	int n, res = 0;
	struct func* funcp;

	if( ! MLGetInteger( mlp, &n) ||  n < 0 ||  n >= nfuncs) goto L0;
	funcp = &functable[n];

	if( funcp->f_nargs >= 0
	&& ( ! MLCheckFunction(mlp, "List", &len)
	     || ( !funcp->manual && (len != funcp->f_nargs))
	     || (  funcp->manual && (len <  funcp->f_nargs))
	   )
	) goto L0;

	stdlink = mlp;
	res = (*funcp->f_func)( mlp);

L0:	if( res == 0)
		res = MLClearError( mlp) && MLPutSymbol( mlp, "$Failed");
	return res && MLEndPacket( mlp) && MLNewPacket( mlp);
} /* _MLDoCallPacket */


mlapi_packet MLAnswer( MLINK mlp)
{
	mlapi_packet pkt = 0;

	while( !MLDone && !MLError(mlp)
	&& (pkt = MLNextPacket(mlp), pkt) && pkt == CALLPKT){
		MLAbort = 0;
		if( !MLDoCallPacket(mlp)) pkt = 0;
	}
	MLAbort = 0;
	return pkt;
}



/*
	Module[ { me = $ParentLink},
		$ParentLink = contents of RESUMEPKT;
		Message[ MessageName[$ParentLink, "notfe"], me];
		me]
*/

static int refuse_to_be_a_frontend( MLINK mlp)
{
	int pkt;

	MLPutFunction( mlp, "EvaluatePacket", 1);
	  MLPutFunction( mlp, "Module", 2);
	    MLPutFunction( mlp, "List", 1);
		  MLPutFunction( mlp, "Set", 2);
		    MLPutSymbol( mlp, "me");
	        MLPutSymbol( mlp, "$ParentLink");
	  MLPutFunction( mlp, "CompoundExpression", 3);
	    MLPutFunction( mlp, "Set", 2);
	      MLPutSymbol( mlp, "$ParentLink");
	      MLTransferExpression( mlp, mlp);
	    MLPutFunction( mlp, "Message", 2);
	      MLPutFunction( mlp, "MessageName", 2);
	        MLPutSymbol( mlp, "$ParentLink");
	        MLPutString( mlp, "notfe");
	      MLPutSymbol( mlp, "me");
	    MLPutSymbol( mlp, "me");
	MLEndPacket( mlp);

	while( (pkt = MLNextPacket( mlp), pkt) && pkt != SUSPENDPKT)
		MLNewPacket( mlp);
	MLNewPacket( mlp);
	return MLError( mlp) == MLEOK;
}


int MLEvaluate( MLINK mlp, charp_ct s)
{
	if( MLAbort) return 0;
	return MLPutFunction( mlp, "EvaluatePacket", 1L)
		&& MLPutFunction( mlp, "ToExpression", 1L)
		&& MLPutString( mlp, s)
		&& MLEndPacket( mlp);
}


int MLEvaluateString( MLINK mlp, charp_ct s)
{
	int pkt;
	if( MLAbort) return 0;
	if( MLEvaluate( mlp, s)){
		while( (pkt = MLAnswer( mlp), pkt) && pkt != RETURNPKT)
			MLNewPacket( mlp);
		MLNewPacket( mlp);
	}
	return MLError( mlp) == MLEOK;
} /* MLEvaluateString */


#if __BORLANDC__
#pragma argsused
#endif

MLMDEFN( void, MLDefaultHandler, ( MLINK mlp, unsigned long message, unsigned long n))
{
#if !__BORLANDC__
	mlp = (MLINK)0; /* suppress unused warning */
	n = 0;          /* suppress unused warning */
#endif

	switch (message){
	case MLTerminateMessage:
		MLDone = 1;
	case MLInterruptMessage:
	case MLAbortMessage:
		MLAbort = 1;
	default:
		return;
	}
}



static int _MLMain( charpp_ct argv, charpp_ct argv_end, charp_ct commandline)
{
	MLINK mlp;
	long err;

	if( !stdenv)
		stdenv = MLInitialize( (MLParametersPointer)0);
	if( stdenv == (MLEnvironment)0) goto R0;

	if( !stdyielder)
		stdyielder = MLCreateYieldFunction( stdenv,
			NewMLYielderProc( MLDefaultYielder), 0);
	if( !stdhandler)
		stdhandler = MLCreateMessageHandler( stdenv,
			NewMLHandlerProc( MLDefaultHandler), 0);


	mlp = commandline
		? MLOpenString( stdenv, commandline, &err)
		: MLOpenArgv( stdenv, argv, argv_end, &err);
	if( mlp == (MLINK)0){
		MLAlert( stdenv, MLErrorString( stdenv, err));
		goto R1;
	}

	if( MLIconWindow){
		char textbuf[64];
		int len;
		len = GetWindowText(MLIconWindow, textbuf, sizeof(textbuf)-2);
		strcat( textbuf + len, "(");
		_fstrncpy( textbuf + len + 1, MLName(mlp), sizeof(textbuf) - len - 3);
		textbuf[sizeof(textbuf) - 2] = '\0';
		strcat( textbuf, ")");
		SetWindowText( MLIconWindow, textbuf);
	}

	if( MLInstance){
		if( stdyielder) MLSetYieldFunction( mlp, stdyielder);
		if( stdhandler) MLSetMessageHandler( mlp, stdhandler);
	}

	if( MLInstall( mlp))
		while( MLAnswer( mlp) == RESUMEPKT){
			if( ! refuse_to_be_a_frontend( mlp)) break;
		}

	MLClose( mlp);
R1:	MLDeinitialize( stdenv);
	stdenv = (MLEnvironment)0;
R0:	return !MLDone;
} /* _MLMain */


int MLMainString( charp_ct commandline)
{
	return _MLMain( (charpp_ct)0, (charpp_ct)0, commandline);
}

int MLMainArgv( char** argv, char** argv_end) /* note not FAR pointers */
{   
	static char FAR * far_argv[128];
	int count = 0;
	
	while(argv < argv_end)
		far_argv[count++] = *argv++;
		 
	return _MLMain( far_argv, far_argv + count, (charp_ct)0);

}

int MLMain( int argc, charpp_ct argv)
{
 	return _MLMain( argv, argv + argc, (charp_ct)0);
}
 
