
/* File: qlib.h
 *
 * exported functions?
 * __
 * UpDates:
 * 18.04.2002 lnkcreatenet and lnkdijkstra added by Vesa
 * 27.05.2002 lnkcreatenet renamed as lnkgabrielnet
 */

double lnkbmitra(int, int, double, int *, long, double *, long);
double lnkbkaufman(int, int, int, int *, long, double *, long);
void   lnkMg1(int, double);
void   lnkSumMd1(int, double);
void   lnkRecMd1(int x, double);
void   lnkMdn(double x, double, int);

/* Function lnkgabrielnet generates a random network containing given number of nodes.
   Node pair connection is based on the Gabriel criterion. Function returns via MathLink
   a list containing two elements:
     1. list containing the coordinates of generated points
     2. distance/cost matrix, in which -1 denotes no connection/infinite cost.
   @param nbr_nodes     number of nodes in the net to be generated
   @param scale         scaling parameter
   @param shape         shape of the net to be generated:
                        0 -> a circle
                        1 -> a box
 */
void lnkgabrielnet (const int nbr_nodes, const double scale, const int shape);

/* Function lnkdijkstra finds out the minimum distance/cost path from
   the given root node to a specific node or to all other nodes in
   the given network. The distance/cost matrix is read manually via MathLink.
   Function returns via MathLink a list containing three elements:
    1. a list of core nodes
    2. a list of previous nodes
    3. a list of distances
   @param root         the root node
   @param target       the destination node
                       if target = -1, then the paths t all nodes in the network
                       are searched
 */
void lnkdijkstra (const int root, const int target);
